(function()
{
	var ns = __namespace( "Astro.Blog.AstroEdit.Visualizer.Snippet" );

	var escapeStr = function ( str )
	{
		if( !str ) return str;
		return str
			.replace( /\[/g, "&#x5B;" )
			.replace( /\]/g, "&#x5D;" )
			.replace( /"/g, "&quot;" )
			;
	};

	var unescapeStr = function( str )
	{
		if( !str ) return str;
		return str
			.replace( /&#x5B;/g, "[" )
			.replace( /&#x5D;/g, "]" )
			.replace( /&quot;/g, "\"" )
			;
	};

	var compileProp = function ( _iDOM, keys )
	{
		var i, j = "", k;
		for (i in keys)
		{
			if( ( k = _iDOM.getDAttribute(keys[i]) ) )
			{
				j += " " + keys[i] + "=\"" + escapeStr( k ) + "\"";
			}
		}
		return j;
	};

	ns[ NS_EXPORT ]( EX_FUNC, "escapeStr", escapeStr );
	ns[ NS_EXPORT ]( EX_FUNC, "unescapeStr", unescapeStr );
	ns[ NS_EXPORT ]( EX_FUNC, "compileProp", compileProp );
})();
